var damage = controller.getData().get("throwing.offHand.damage");
var enabled = true;
var inHand = controller.getData().get("gear.locations.offHand");
if (inHand != null && inHand.equals("Unique Weapons")) {
  component.setText(0);
  component.setEditable(true);
} else if (dmage == null || damage.trim().length() == 0) {
  component.setText("");
  enabled = false;
  component.setEditable(false);
} else {
  component.setText(value);
  component.setEditable(false);
} // endif
component.setEnabled(enabled);
controller.getPanel().getButton("throwing.offHand.damageRoll").setEnabled(enabled);
controller.getPanel().getButton("throwing.offHand.throwingRoll").setEnabled(enabled);
controller.getPanel().getLabel("throwing.offHand.currentMods").setEnabled(enabled);
controller.getPanel().getComboBox("throwing.offHand.rangeIncrement").setEnabled(enabled);
controller.getPanel().getComboBox("throwing.offHand.cover").setEnabled(enabled);

var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util, java.awt);
with (Java) {
  var hints = new HashMap();
  hints.put(CharSheetUtils.SIZE_HINT, new Dimension(567, 325));
  hints.put(CharSheetUtils.PREFERENCES_HINT, "GURPS-editStats");
  CharSheetUtils.showCharSheetSubFormDialog(rpComponent, "Edit Attributes", null, "forms/editStats.jfrm", hints);
}

var data=rpController.getData();
if (data!= null) {
  data.put("HP.value", data.get("HP.base"));
  data.put("Will.value", data.get("Will.base"));
  data.put("Per.value", data.get("Per.base"));
  data.put("FP.value", data.get("FP.base"));
  data.put("basicSpeed.value", data.get("basicSpeed.base"));
  data.put("basicMove.value", data.get("basicMove.base"));
  rpController.setFields();
}



//JavaScript::
var Java = new JavaImporter(java.awt);
with (Java) {
  var colors = new Array(Color.decode("#588d60"), Color.decode("#80142e"), Color.decode("#3d3f3f"));
  var color = null;
  var power = rpComponent.getData().get(rpComponent.getModel().getActualModel().getRowPropName(rpComponent.getActualRowAt(rpRow)));
  var type = power.get("type");
  if (type == "At-Will") {
    color = colors[0];
  } else if (type == "Encounter") {
    color = colors[1];
  } else if (type == "Daily") {
    color = colors[2];
  } // endif  
  if (rpIsSelected) 
    color = color.darker()
  rpRenderer.setBackground(color);
  rpRenderer.setForeground(Color.WHITE);
}

//JavaScript::
var Java = new JavaImporter(javax.swing, com.jgoodies.forms.layout);
with (Java) {
  rpValue = rpValue.replace(/^\s+|\s+$/g, '');
  if (rpValue == null || rpValue.length == 0) {
    var p = SwingUtilities.getAncestorNamed("_" + rpComponent.getName(), rpComponent)
    var fp = rpController.getPanel();
    var cc = fp.getFormAccessor().getConstraints(p.getParent().getParent());
    var fl = fp.getFormContainer().getLayout();
    p.setVisible(false);
    fl.setRowSpec(cc.gridY, new RowSpec("0px"));
  } else {
    rpComponent.setText(rpValue);
  } // endif
}

//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util, java.awt);
with (Java) {
  var hints = new HashMap();
  hints.put(CharSheetUtils.SIZE_HINT, new Dimension(580, 374));
  hints.put(CharSheetUtils.PREFERENCES_HINT, "dnd4e_powerView");
  hints.put(CharSheetUtils.CONTEXT_HINT, rpCntroller.getData().get(rpComponent.getClientProperty("row")));
  CharSheetUtils.showCharSheetSubFormDialog(rpComponent, "Power", null, "forms/powerView.jfrm", hints);
}

var Java = new JavaImporter(javax.swing);
with (Java) {
  var bg = new ButtonGroup();
  bg.add(rpComponent);
  bg.add(rpController.getPanel().getComponentByName("_mainHadSelectionButton"));
}

// When a row is selected set it as the row property on the _useSkillButton
if (!rpEvent.getValueIsAdjusting()) {
  
  // Setup base data
  var panel = rpController.getPanel();
  var enable = rpComponent.getSelectedRow() >= 0;
  var buttons = new Array("_usePowerButton", "_viewPowerButton", "_powerAttackButton", "_powerDamageButton", "_powerCritButton",
                          "_primaryAttack", "_secondaryAttack", "_tertiaryAttack");

  // When enabling, find out if there are attacks available for the selected power
  var selectedAttack = 5;
  var workingRow = null;
  if (enable) {
    workingRow = rpComponent.getModel().getActualModel().getRowPropName(rpComponent.getActualRowAt(rpComponent.getSelectedRow()));
    var p = rpComponent.getData().get(workingRow);
    var re = /^\s+|\s+$/g
    var primaryAttack = String(p.get("attack")).replace(re, "") != "";
    var secondaryAttack = String(p.get("secondaryAttack")).replace(re, "") != "";
    var tertiaryAttack = String(p.get("tertiaryAttack")).replace(re, "") != "";
    var anyAttack = primaryAttack || secondaryAttack || tertiaryAttack;
    selectedAttack = primaryAttack ? 5 : secondaryAttack ? 6 : tertiaryAttack ? 7 : 5;
    var buttonEnable = new Array(true, true, anyAttack, anyAttack, anyAttack, primaryAttack, secondaryAttack, tertiaryAttack);
  } // endif
  
  // Set the buttons
  for (var i = 0; i < buttons.length; i++) {
    var button = panel.getComponentByName(buttons[i]);
    button.setEnabled(enable && buttonEnable[i]);
    button.putClientProperty("row", workingRow);
    if (i == selectedAttack) button.setSelected(true);
  } // endif
}


//JavaScript::
var Java = new JavaImporter(java.awt);
with (Java) {
  var colors = new Array(Color.decode("#588d60"), Color.decode("#80142e"), Color.decode("#3d3f3f"), Color.decode("e5e5e5"));
  var bg = null;
  var fg = Color.WHITE;
  var power = rpComponent.getData().get(rpComponent.getModel().getActualModel().getRowPropName(rpComponent.getActualRowAt(rpRow)));
  var type = power.get("type");
  if (power.get("available").booleanValue()) {
    bg = colors[4];
    fg = Color.BLACK;
  } if (type == "At-Will") {
    bg = colors[0];
  } else if (type == "Encounter") {
    bg = colors[1];
  } else if (type == "Daily") {
    bg = colors[2];
  } // endif  
  if (rpIsSelected)
    bg = bg.brighter().brighter();
  var alignment = 0;
  if (rpComponent.convertColumnIndexToModel(rpColumn) == 0) alignment = 2;
  rpRenderer.setHorizontalAlignment(alignment);
  rpRenderer.setBackground(bg);
  rpRenderer.setForeground(fg);
}

//JavaScript::
var Java = new JavaImporter(java.awt);
with (Java) {
  var colors = new Array(Color.decode("#588d60"), Color.decode("#80142e"), Color.decode("#3d3f3f"));
  var bg = null;
  var power = rpComponent.getData().get(rpComponent.getModel().getActualModel().getRowPropName(rpComponent.getActualRowAt(rpRow)));
  var type = power.get("type");
  if (type == "At-Will") {
    bg = colors[0];
  } else if (type == "Encounter") {
    bg = colors[1];
  } else if (type == "Daily") {
    bg = colors[2];
  } // endif  
  if (rpIsSelected)
    bg = bg.brighter();
  var alignment = 0;
  if (rpComponent.convertColumnIndexToModel(rpColumn) == 0)
    alignment = power.get("available").booleanValue() ? 2 : 4;
  rpRenderer.setHorizontalAlignment(alignment);
  rpRenderer.setBackground(bg);
}

//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util,
                            net.rptools.chartool.model.property);  
with (Java) {
  var eqChoice = rpController.getPanel().getSelectedItem("_equipmentChoice").getLabel();
  if (eqChoice == "ARMOR") {
    props = new Array("name", "armorType", "armorBonus", "price", "weight");
    dataType = "armor";
    eqChoice = "Armor";
  } else if (eqChoice == "WEAPONS") {
    props = new Array("name", "damageDie", "group", "category", "price", "weight");
    dataType = "weapon";
    eqChoice = "Weapon";
  } else if (eqChoice == "EQUIPMENT") {
    props = new Array("name", "price", "weight");
    dataType = "equipment";
    eqChoice = "Equipment";
  } // endif
  var hints = new HashMap();
  hints.put(CharSheetUtils.CONTEXT_HINT, rpController.getData());
  var dialog = CharSheetUtils.addToListFromGameSettingsTable(rpComponent, "Add " + eqChoice, 
                         "Select " + eqChoice + " to add to this combatant.", dataType, props, 
                         rpController.getData(), "equipment.items", hints);
}

//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util,
                            net.rptools.chartool.model.property);  
with (Java) {
  
  var props = new Array("name", "type", "source", "level", "action", "prerequisite", "target", "attack", "defense", "hit");
  var hints = new HashMap();
  hints.put(Utils.SHOW_RECORDS_HINT, Utils.findKeys(rpController.getData().get("powers.powers")));
  hints.put(CharSheetUtils.CONTEXT_HINT, rpController.getData());
  var dialog = CharSheetUtils.removeFromListFromGameSettingsTable(rpEvent.getSource(), "Remove Powers", 
                         "Select Powers to remove from this combatant.", "power", props, 
                         rpController.getData(), "powers.powers", hints);
}


          var m = "";
          var t = effect.replace(/^\s+|\s+$/g, '');
          if (t.length > 0) m = m + "<b>Effect:</b> " + t + "<br/>";
          var t = miss.replace(/^\s+|\s+$/g, '');
          if (t.length > 0) m = m + "<b>Miss:</b> " + t + "<br/>";
          var t = notes.replace(/^\s+|\s+$/g, '');
          if (t.length > 0) m = m + "<b>Notes:</b> " + t + "<br/>";
          if (m.length > 0) m = "<html>" + m + "</html>"
          m;
          
//JavaScript::
var e = root.get("equipment.items");
var r = "";
if (e != null && !e.isEmpty()) {
  for (var i = 0; i < e.size(); i++) {
    if (e.get(i).get("slot") == "Weapon")
      r = r + ((r.length == 0) ? "" : " ") + i; 
  } // endfor
} // endif
e = "equipment.items";
if (r.length == 0) e = null;
rpComponent.setComboBoxModelProp(e);
rpComponent.setComboBoxModelRows(r);
rpComponent.setSelectedItem(rpValue)

//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util,
                            net.rptools.chartool.model.property);  
with (Java) {
  var eqChoice = rpController.getPanel().getSelectedItem("_equipmentChoice").getLabel();
  if (eqChoice == "ARMOR") {
    props = new Array("name", "armorType", "armorBonus", "price", "weight");
    dataType = "armor";
    eqChoice = "Armor";
  } else if (eqChoice == "WEAPONS") {
    props = new Array("name", "damageDie", "group", "category", "price", "weight");
    dataType = "weapon";
    eqChoice = "Weapon";
  } else if (eqChoice == "EQUIPMENT") {
    props = new Array("name", "price", "weight");
    dataType = "equipment";
    eqChoice = "Equipment";
  } // endif
  var hints = new HashMap();
  hints.put(CharSheetUtils.CONTEXT_HINT, rpController.getData());
  hints.put(Utils.DEFAULT_MODIFIER_SET_NAME_COLUMN, "dontApplyMods");
  var dialog = CharSheetUtils.addToListFromGameSettingsTable(rpComponent, "Add " + eqChoice, 
                         "Select " + eqChoice + " to add to this combatant.", dataType, props, 
                         rpController.getData(), "equipment.items", hints);
}


//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.ui.charsheet.component, java.util, net.rptools.chartool.model.property, java.awt, javax.swing);
with (Java) {
  var r = rpComponent.getClientProperty("row").intValue();
  var oldSpv = rpController.getData().get("rpUserMacros").get(r);
  var spv = new SlotPropertyValue('macro');
  spv.put('name', oldSpv.get('name'));
  spv.put('macroText', oldSpv.get('macroText') + "mine");
  var hints = new HashMap();
  hints.put(CharSheetUtils.CONTEXT_HINT, spv);
  hints.put(CharSheetUtils.SIZE_HINT, new Dimension(500, 270));
  var finished = false;
  while (!finished) {
    var ok = CharSheetUtils.showCharSheetSubFormDialog(rpComponent, "Edit Macro", "Edit this macro.",
                                                       "forms/editTokenMacroDialog.jfrm", hints);
    if (ok) {
      if (oldSpv.get('name') == spv.get('name') || Utils.getListItem(rpController.getData().get('rpUserMacros'), spv.get('name'), 'name', null) == null) {
        oldSpv.put('name', spv.get('name'));
        oldSpv.put('macroText', spv.get('macroText'));
        rpController.setFields();
        finished = true;
      } else {
        JOptionPane.showMessageDialog(rpComponent, "Duplicate macros are not allowed and a macro named '" + spv.get('name') + "' already exists.", 
                                                               "Error!", JOptionPane.ERROR_MESSAGE);
      } // endif
    } else {
      finished = true;
    } // endif
  } // endwhile
  "";
} // endwith

//JavaScript::
var Java = new JavaImporter(net.rptools.chartool.model.property);
with (Java) {
  var n = 'Prone';
  var spv = new SlotPropertyValue("condition", n);
  var selected = rpComponent.isSelected();
  var conditions = rpController.getData().get("conditions");
  if (selected) {
    conditions.add(spv);
  } else {
    var i = conditions.iterator();
    while (i.hasNext()) {
      var c = i.next();
      if (c.get('name') == n) {
        conditions.remove(c);
        break;
      } // endif
    } // endwhile
  } // endif
} // endwith

//JavaScript::
// Disable when not running IT
var Java = new JavaImporter(net.rptools.inittool.model);
with (Java) {
  try {
    new Creature();
    rpComponent.setEnabled(true);
  } catch (e) {
    rpComponent.setEnabled(false);
  } 
} // endwith

//JavaScript::
var Java = new JavaImporter(net.rptools.inittool.model, net.rptools.inittool.ui);
with (Java) {
  var f = InitToolFrame.getInstance();
  var e = f.getEncounter();
  var i = f.getActions().getSelectedOrCurrentItem();
  if (i != null) {
    var t = new TimerInitItem(rpController.getData().get('name') + "'s +1 Action", 
                              InitToolGameSettings.getInstance().getTimerType('Secondary Actions'));
    t.setExpirationRound(e.getRound());
    t.setInitiative(i.getInitiative() - 8);
    t.setOwner(i);
    e.addItem(t, -1);
  } // endif
} // endwith
